<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="" xml:lang="">
  <head>
    <meta charset="utf-8" />
    <meta name="generator" content="pandoc" />
    <meta
      name="viewport"
      content="width=device-width, initial-scale=1.0, user-scalable=yes"
    />
    <title>regex-cheatsheet</title>
    <style type="text/css">
      code {
        white-space: pre-wrap;
      }
      span.smallcaps {
        font-variant: small-caps;
      }
      span.underline {
        text-decoration: underline;
      }
      div.column {
        display: inline-block;
        vertical-align: top;
        width: 50%;
      }
    </style>
  </head>
  <body>
    <h2 id="basic-definitions">Basic definitions</h2>
    <ul>
      <li>
        String <code>s</code> <em>matches</em> the regex pattern
        <code>/p/</code> whenever <code>s</code> contains the pattern ‘p’.
        <ul>
          <li>
            Example: <code>abc</code> matches <code>/a/</code>,
            <code>/b/</code>, <code>/c/</code>
          </li>
        </ul>
      </li>
      <li>
        For simplicity, we will use the <em>matches</em> verb loosely in a sense
        that
        <ul>
          <li>a string can <em>match</em> a regex (e.g. ‘a’ matches /a/)</li>
          <li>a regex can <em>match</em> a string (e.g. /a/ matches ‘a’)</li>
        </ul>
      </li>
      <li>
        A regex pattern consists of <em>literal characters</em> that match
        itself, and <em>metasyntax characters</em>
      </li>
      <li>
        Literal characters can be <em>concatenated</em> in a regular expression.
        String <code>s</code> matches <code>/ab/</code> if there is an
        <code>a</code> character *directly followed by a
        <code>b</code> character.
        <ul>
          <li>
            Example: <code>abc</code> matches <code>/ab/</code>,
            <code>/bc/</code>, <code>/abc/</code>
          </li>
          <li>
            Example: <code>abc</code> does not match <code>/ac/</code>,
            <code>/cd/</code>, <code>/abcd/</code>
          </li>
        </ul>
      </li>
      <li>
        <em>Alternative execution</em> can be achieved with the metasyntax
        character <code>|</code>
        <ul>
          <li>
            <code>/a|b/</code> means: match either <code>a</code> or
            <code>b</code>
          </li>
          <li>Example: ‘ac’, ‘b’, ‘ab’ match <code>/a|b/</code></li>
          <li>Example: ‘c’ does not match <code>/a|b/</code></li>
        </ul>
      </li>
      <li>
        Iteration is achieved using repeat modifiers. One repeat modifier is the
        <code>*</code> (asterisk) metasyntax character.
        <ul>
          <li>
            Example: <code>/a*/</code> matches any string containing any number
            of <code>a</code> characters
          </li>
          <li>
            Example: <code>/a*/</code> matches any string, including
            <code>''</code>, because they all contain at least zero
            <code>a</code> characters
          </li>
        </ul>
      </li>
      <li>
        Matching is <em>greedy</em>. A <em>greedy</em> match attempts to stay in
        iterations as long as possible.
        <ul>
          <li>
            Example: <code>s = 'baaa'</code> matches <code>/a*a/</code> in the
            following way:
            <ul>
              <li><code>s[0]</code>: <code>'b'</code> is discarded</li>
              <li>
                <code>s[1]</code>: <code>'a'</code> matches the pattern
                <code>a*</code>
              </li>
              <li>
                <code>s[1] - s[2]</code>: <code>'aa'</code> matches the pattern
                <code>a*</code>
              </li>
              <li>
                <code>s[1] - s[3]</code>: <code>'aaa'</code> matches the pattern
                <code>a*</code>
              </li>
              <li>
                as there are no more characters in <code>s</code> and there is a
                character yet to be matched in the regex, we
                <em>backtrack</em> one character
              </li>
              <li>
                <code>s[1] - s[2]</code>: <code>'aa'</code> matches the pattern
                <code>a*</code>, and we end investigating the
                <code>a*</code> pattern
              </li>
              <li>
                <code>s[3]</code>: <code>'a'</code> matches the
                <code>a</code> pattern
              </li>
              <li>
                there is a complete match, <code>s[1] - s[2]</code> match the
                <code>a*</code> pattern, and <code>s[3]</code> matches the
                <code>a</code> pattern. The returned match is
                <code>aaa</code> starting at index <code>1</code> of string
                <code>s</code>
              </li>
            </ul>
          </li>
        </ul>
      </li>
      <li>
        Backtracking is <em>minimal</em>. We attempt to backtrack one character
        at a time in the string, and attempt to interpret the rest of the regex
        pattern on the remainder of the string.
      </li>
    </ul>
    <h2 id="constructing-a-regex">Constructing a regex</h2>
    <ul>
      <li>literal form: <code>/regex/</code></li>
      <li>
        constructor: <code>new RegExp( 'regex' );</code>
        <ul>
          <li>
            escaping: <code>/\d/</code> becomes <code>new RegExp( '\\d' )</code>
          </li>
          <li>argument list: <code>new RegExp( pattern, modifiers );</code></li>
        </ul>
      </li>
    </ul>
    <p>Applying modifiers in literal form:</p>
    <pre><code>const regex1 = new RegExp( &#39;regex&#39;, &#39;ig&#39; );
const regex2 = /regex/ig;</code></pre>
    <ul>
      <li>
        <code>RegExp</code> constructor also accepts a regular expression:
      </li>
    </ul>
    <pre><code>&gt; new RegExp( /regex/, &#39;i&#39; );
/regex/i</code></pre>
    <h2 id="list-of-javascript-regex-modifiers">
      List of JavaScript regex modifiers
    </h2>
    <table>
      <colgroup>
        <col style="width: 43%" />
        <col style="width: 56%" />
      </colgroup>
      <thead>
        <tr class="header">
          <th>Modifier</th>
          <th>Description</th>
        </tr>
      </thead>
      <tbody>
        <tr class="odd">
          <td><code>i</code></td>
          <td>
            non-case sensitive matching. Upper and lower cases don’t matter.
          </td>
        </tr>
        <tr class="even">
          <td></td>
          <td></td>
        </tr>
        <tr class="odd">
          <td><code>g</code></td>
          <td>
            global match. We attempt to find all matches instead of just
            returning the first match. The internal state of the regular
            expression stores where the last match was located, and matching is
            resumed where it was left in the previous match.
          </td>
        </tr>
        <tr class="even">
          <td></td>
          <td></td>
        </tr>
        <tr class="odd">
          <td><code>m</code></td>
          <td>
            multiline match. It treats the <code>^</code> and
            <code>$</code> characters to match the beginning and the end of each
            line of the tested string. A newline character is determined by
            <code>\n</code> or <code>\r</code>.
          </td>
        </tr>
        <tr class="even">
          <td></td>
          <td></td>
        </tr>
        <tr class="odd">
          <td><code>u</code></td>
          <td>
            unicode search. The regex pattern is treated as a unicode sequence
          </td>
        </tr>
        <tr class="even">
          <td></td>
          <td></td>
        </tr>
        <tr class="odd">
          <td><code>y</code></td>
          <td>Sticky search</td>
        </tr>
      </tbody>
    </table>
    <p>Example:</p>
    <pre><code>&gt; const str = &#39;Regular Expressions&#39;;

&gt; /re/.test( str );
false
&gt; /re/i.test( str ); // matches: &#39;re&#39;, &#39;Re&#39;, &#39;rE&#39;, &#39;RE&#39;
true</code></pre>
    <h2 id="regex-api">Regex API</h2>
    <ul>
      <li>
        <code>regex.exec( str )</code>: returns information on the first match.
        Exec allows iteration on the regex for all matches if the
        <code>g</code> modifier is set for the regex
      </li>
      <li>
        <code>regex.test( str )</code>: true iff regex <em>matches</em> a string
      </li>
    </ul>
    <pre><code>&gt; const regex = /ab/;
&gt; const str = &#39;bbababb&#39;;
&gt; const noMatchStr = &#39;c&#39;;

&gt; regex.exec( str ); // first match is at index 2
[ 0: &quot;ab&quot;, index: 2, input: &quot;bbababb&quot; ]
&gt; regex.exec( noMatchStr );
null

&gt; regex.test( str );
true
&gt; regex.test( noMatchStr );
false

&gt; regex.exec( noMatchStr );

&gt; const globalRegex = /ab/g;
&gt; globalRegex.exec( str );
&gt; globalRegex.exec( str );
[ 0: &quot;ab&quot;, index: 2, input: &quot;bbababb&quot; ]
&gt; globalRegex.exec( str );
[ 0: &quot;ab&quot;, index: 4, input: &quot;bbababb&quot; ]
&gt; globalRegex.exec( str );
null

&gt; let result;
&gt; while ( ( result = globalRegex.exec( str ) ) !== null ) {
      console.log( result );
  }
[ 0: &quot;ab&quot;, index: 2, input: &quot;bbababb&quot; ]
[ 0: &quot;ab&quot;, index: 4, input: &quot;bbababb&quot; ]  </code></pre>
    <h2 id="string-api">String API</h2>
    <ul>
      <li>
        <code>str.match( regex )</code>: for non-global regular expression
        arguments, it returns the same return value as
        <code>regex.exec( str )</code>. For global regular expressions, the
        return value is an array containing all the matches. Returns
        <code>null</code> if no match has been found.
      </li>
      <li>
        <code>str.replace( regex, newString )</code>: replaces the first full
        match with <code>newString</code>. If <code>regex</code> has a global
        modifier, <code>str.replace( regex, newString )</code> replaces all
        matches with <code>newString</code>. Does not mutate the original string
        <code>str</code>.
      </li>
      <li>
        <code>str.search( regex )</code>: returns the index of the first match.
        Returns <code>-1</code> when no match is found. Does not consider the
        global modifier.
      </li>
      <li>
        <code>str.split( regex )</code>: does not consider the global modifier.
        Returns an array of strings containing strings in-between matches.
      </li>
    </ul>
    <pre><code>&gt; const regex = /ab/;
&gt; const str = &#39;bbababb&#39;;
&gt; const noMatchStr = &#39;c&#39;;

&gt; str.match( regex );
[&quot;ab&quot;, index: 2, input: &quot;bbababb&quot;]

&gt; str.match( globalRegex );
[&quot;ab&quot;, &quot;ab&quot;]

&gt; noMatchStr.match( globalRegex );
null

&gt; str.replace( regex, &#39;X&#39; );
&quot;bbXabb&quot;

&gt; str.replace( globalRegex, &#39;X&#39; )
&quot;bbXXb&quot;

&gt; str.search( regex );
2

&gt; noMatchStr.search( regex );
-1

&gt; str.split( regex );
[&quot;bb&quot;, &quot;&quot;, &quot;b&quot;]

&gt; noMatchStr.split( regex );
[&quot;c&quot;]</code></pre>
    <h2 id="literal-characters">Literal characters</h2>
    <p>
      A regex <em>literal character</em> matches itself. The expression
      <code>/a/</code> matches any string that contains the
      <code>a</code> character. Example:
    </p>
    <pre><code>/a/.test( &#39;Andrea&#39; )   // true, because the last character is &#39;a&#39;
/a/.test( &#39;André&#39; )    // false, because there is no &#39;a&#39; in the string
/a/i.test( &#39;André&#39;)    // true, because &#39;A&#39; matches /a/i with the case-insensitive flag `i` applied on `/a/`</code></pre>
    <p>
      Literal characters are: all characters except metasyntax characters such
      as: <code>.</code>, <code>*</code>, <code>^</code>, <code>$</code>,
      <code>[</code>, <code>]</code>, <code>(</code>, <code>)</code>,
      <code>{</code>, <code>}</code>, <code>|</code>, <code>?</code>,
      <code>+</code>, <code>\</code>
    </p>
    <p>
      When you need a metasyntax character, place a backslash in front of it.
      Examples: <code>\.</code>, <code>\\</code>, <code>\[</code>.
    </p>
    <p>
      Whitespaces: - behave as literal characters, exact match is required - use
      character classes for more flexibility, such as: - <code>\n</code> for a
      newline - <code>\t</code> for a tab - <code>\b</code> for word boundaries
    </p>
    <h2 id="metasyntax-characters">Metasyntax characters</h2>
    <table>
      <colgroup>
        <col style="width: 66%" />
        <col style="width: 33%" />
      </colgroup>
      <thead>
        <tr class="header">
          <th>Metasyntax character</th>
          <th>Semantics</th>
        </tr>
      </thead>
      <tbody>
        <tr class="odd">
          <td><code>.</code></td>
          <td>arbitrary character class</td>
        </tr>
        <tr class="even">
          <td></td>
          <td></td>
        </tr>
        <tr class="odd">
          <td><code>[]</code></td>
          <td>character sets, <code>[012]</code> means 0, or 1, or 2</td>
        </tr>
        <tr class="even">
          <td></td>
          <td></td>
        </tr>
        <tr class="odd">
          <td><code>^</code></td>
          <td>
            (1) negation, e.g. in a character set <code>[^890]</code> means not
            8, not 9, and not 10, (2) anchor matching the start of the string or
            line
          </td>
        </tr>
        <tr class="even">
          <td></td>
          <td></td>
        </tr>
        <tr class="odd">
          <td><code>$</code></td>
          <td>anchor matching the end of the string or line</td>
        </tr>
        <tr class="even">
          <td></td>
          <td></td>
        </tr>
        <tr class="odd">
          <td><code>|</code></td>
          <td>alternative execution (or)</td>
        </tr>
        <tr class="even">
          <td></td>
          <td></td>
        </tr>
        <tr class="odd">
          <td><code>*</code></td>
          <td>iteration: match any number of times</td>
        </tr>
        <tr class="even">
          <td></td>
          <td></td>
        </tr>
        <tr class="odd">
          <td><code>?</code></td>
          <td>optional parts in the expression</td>
        </tr>
        <tr class="even">
          <td></td>
          <td></td>
        </tr>
        <tr class="odd">
          <td><code>+</code></td>
          <td>match at least once</td>
        </tr>
        <tr class="even">
          <td></td>
          <td></td>
        </tr>
        <tr class="odd">
          <td><code>{}</code> and <code>{,}</code></td>
          <td>
            specify a range for the number of times an expression has to match
            the string. Forms: <code>{3}</code> exactly 3 times,
            <code>{3,}</code> at least 3 times, <code>{3,5}</code> between 3 and
            5 times.
          </td>
        </tr>
        <tr class="even">
          <td></td>
          <td></td>
        </tr>
        <tr class="odd">
          <td><code>()</code></td>
          <td>
            (1) overriding precedence through grouping, (2) extracting
            substrings
          </td>
        </tr>
        <tr class="even">
          <td></td>
          <td></td>
        </tr>
        <tr class="odd">
          <td><code>\</code></td>
          <td>
            (1) before a metasyntax character: the next character becomes a
            literal character (e.g. <code>\\</code>). (2) before a special
            character: the sequence is interpreted as a special character
            sequence (e.g. <code>\d</code> as digit).
          </td>
        </tr>
        <tr class="even">
          <td></td>
          <td></td>
        </tr>
        <tr class="odd">
          <td><code>(?:</code>, <code>)</code></td>
          <td>
            non-capturing parentheses. Anything in-between <code>(?:</code> and
            <code>)</code> is matched, but not captured. Should be used to
            achieve only functionality (1) of <code>()</code> parentheses.
          </td>
        </tr>
        <tr class="even">
          <td></td>
          <td></td>
        </tr>
        <tr class="odd">
          <td><code>(?=</code>, <code>)</code></td>
          <td>
            lookahead. E.g. <code>.(?=end)</code> matches an arbitrary character
            if it is followed by the characters <code>end</code>. Only the
            character is returned in the match, <code>end</code> is excluded.
          </td>
        </tr>
        <tr class="even">
          <td></td>
          <td></td>
        </tr>
        <tr class="odd">
          <td><code>(?!</code>, <code>)</code></td>
          <td>
            negative lookahead. E.g. <code>.(?!end)</code> matches an arbitrary
            character if it is <strong>not</strong> followed by the characters
            <code>end</code>. Only the character is returned in the match,
            <code>end</code> is excluded.
          </td>
        </tr>
        <tr class="even">
          <td></td>
          <td></td>
        </tr>
        <tr class="odd">
          <td><code>\b</code></td>
          <td>
            word boundary. Zero length assertion. Matches the start or end
            position of a word. E.g. <code>\bworld\b</code> matches the string
            <code>'the world'</code>
          </td>
        </tr>
        <tr class="even">
          <td></td>
          <td></td>
        </tr>
        <tr class="odd">
          <td><code>[\b]</code></td>
          <td>
            matches a backspace character. This is <strong>not</strong> a
            character set including a word boundary.
          </td>
        </tr>
        <tr class="even">
          <td></td>
          <td></td>
        </tr>
        <tr class="odd">
          <td><code>\B</code></td>
          <td>not a word boundary.</td>
        </tr>
        <tr class="even">
          <td></td>
          <td></td>
        </tr>
        <tr class="odd">
          <td><code>\c</code></td>
          <td>
            <code>\c</code> is followed by character <code>x</code>.
            <code>\cx</code> matches <code>CTRL + x</code>.
          </td>
        </tr>
        <tr class="even">
          <td></td>
          <td></td>
        </tr>
        <tr class="odd">
          <td><code>\d</code></td>
          <td>digit. <code>[0-9]</code></td>
        </tr>
        <tr class="even">
          <td></td>
          <td></td>
        </tr>
        <tr class="odd">
          <td><code>\D</code></td>
          <td>non-digit. <code>[^0-9]</code></td>
        </tr>
        <tr class="even">
          <td></td>
          <td></td>
        </tr>
        <tr class="odd">
          <td><code>\f</code></td>
          <td>form feed character</td>
        </tr>
        <tr class="even">
          <td></td>
          <td></td>
        </tr>
        <tr class="odd">
          <td><code>\n</code></td>
          <td>newline character (line feed)</td>
        </tr>
        <tr class="even">
          <td></td>
          <td></td>
        </tr>
        <tr class="odd">
          <td><code>\r</code></td>
          <td>carriage return character</td>
        </tr>
        <tr class="even">
          <td></td>
          <td></td>
        </tr>
        <tr class="odd">
          <td><code>\s</code></td>
          <td>one arbitrary white space character</td>
        </tr>
        <tr class="even">
          <td></td>
          <td></td>
        </tr>
        <tr class="odd">
          <td><code>\S</code></td>
          <td>one non-whitespace character</td>
        </tr>
        <tr class="even">
          <td></td>
          <td></td>
        </tr>
        <tr class="odd">
          <td><code>\t</code></td>
          <td>tab character</td>
        </tr>
        <tr class="even">
          <td></td>
          <td></td>
        </tr>
        <tr class="odd">
          <td><code>\u</code></td>
          <td>
            <code>\u</code> followed by four hexadecimal digits matches a
            unicode character described by those four digits when the
            <code>u</code> flag is not set. When the <code>u</code> flag is set,
            use the format <code>\u{0abc}</code>.
          </td>
        </tr>
        <tr class="even">
          <td></td>
          <td></td>
        </tr>
        <tr class="odd">
          <td><code>\v</code></td>
          <td>vertical tab character</td>
        </tr>
        <tr class="even">
          <td></td>
          <td></td>
        </tr>
        <tr class="odd">
          <td><code>\w</code></td>
          <td>alphanumeric character. <code>[A-Za-z0-9_]</code></td>
        </tr>
        <tr class="even">
          <td></td>
          <td></td>
        </tr>
        <tr class="odd">
          <td><code>\W</code></td>
          <td>non-alphanumeric character</td>
        </tr>
        <tr class="even">
          <td></td>
          <td></td>
        </tr>
        <tr class="odd">
          <td><code>\x</code></td>
          <td>
            <code>\x</code> followed by two hexadecimal digits matches the
            character described by those two digits.
          </td>
        </tr>
        <tr class="even">
          <td></td>
          <td></td>
        </tr>
        <tr class="odd">
          <td><code>\0</code></td>
          <td>
            NULL character. Equivalent to <code>\x00</code> and
            <code>\u0000</code>. When the <code>u</code> flag is set for the
            regex, it is equivalent to <code>\u{0000}</code>.
          </td>
        </tr>
        <tr class="even">
          <td></td>
          <td></td>
        </tr>
        <tr class="odd">
          <td><code>\1</code>, <code>\2</code>, …</td>
          <td>
            backreference. <code>\i</code> is a reference to the matched
            contents of the <em>i</em>th capture group.
          </td>
        </tr>
      </tbody>
    </table>
    <p>Examples:</p>
    <pre><code>/.../.test( &#39;ab&#39; )  // false, we need at least three arbitrary characters
/.a*/.test( &#39;a&#39; )   // true, . matches &#39;a&#39;, and a* matches &#39;&#39;
/^a/.test( &#39;ba&#39; )   // false, &#39;ba&#39; does not start with a
/^a/.test( &#39;ab&#39; )   // true, &#39;ab&#39; starts with a
/a$/.test( &#39;ba&#39; )   // true, &#39;ba&#39; ends with a
/a$/.test( &#39;ab&#39; )   // false, &#39;ab&#39; does not end with a
/^a$/.test( &#39;ab&#39; )  // false, &#39;ab&#39; does not fully match a
/^a*$/.test( &#39;aa&#39; ) // true, &#39;aa&#39; fully matches a pattern consisting of
                    // a characters only
/[ab]/.test( &#39;b&#39; )  // true, &#39;b&#39; contains a character that is a
                    // member of the character class `[ab]`
/a|b/.test( &#39;b&#39; )   // true, &#39;b&#39; contains a character that is 
                    // either `a` or `b`
/ba?b/.test( &#39;bb&#39; ) // true, the optional a is not included
/ba?b/.test( &#39;bab&#39;) // true, the optional a is included
/ba?b/.test( &#39;bcb&#39;) // false, only matches &#39;bb&#39; or &#39;bab&#39;
/a+/.test( &#39;&#39; )     // false, at least one `a` character is needed
/a+/.test( &#39;ba&#39; )   // true, the `a` character was found
/a{3}/.test(&#39;baaab&#39;)// true, three consecutive &#39;a&#39; characters were found  
/(a|b)c/.test(&#39;abc&#39;)// true, a `b` character is followed by `c`
/a(?=b)/.test(&#39;ab&#39;) // true. It matches &#39;a&#39;, because &#39;a&#39; is followed by &#39;b&#39;
/a(?!b)/.test(&#39;ab&#39;) // false, because &#39;a&#39; is not followed by &#39;b&#39;
/\ba/.test(&#39;bab&#39;)   // false, because &#39;a&#39; is not the first character of a word
/\Ba/.test(&#39;bab&#39;)   // true, because &#39;a&#39; is not the first character of a word
/(\d)\1/.test(&#39;55&#39;) // true. It matches two consecutive digits with the same value</code></pre>
    <p>
      In the last example, notice the parentheses. As the
      <code>|</code> operator has the lowest precedence out of all operators,
      parentheses made it possible to increase the prcedence of the alternative
      execution <code>a|b</code> higher than concatenation <code>(a|b)c</code>.
    </p>
    <h2 id="character-sets-character-classes">
      Character sets, character classes
    </h2>
    <ul>
      <li><code>[abc]</code> is <code>a|b|c</code></li>
      <li><code>[a-c]</code> is <code>[abc]</code></li>
      <li><code>[0-9a-fA-F]</code> is a case-insensitive hexadecimal digit</li>
      <li>
        <code>[^abc]</code> is an arbitrary character that is not
        <code>a</code>, not <code>b</code>, and not <code>c</code>
      </li>
      <li>
        <code>.</code>: arbitrary character class
        <ul>
          <li>
            Example: <code>/..e/</code>: three character sequence ending with
            <code>e</code>
          </li>
        </ul>
      </li>
      <li>
        other character classes such as digit (<code>\d</code>), not a digit
        (<code>\D</code>), word (<code>\w</code>), not a word (<code>\W</code>),
        whitespace character (<code>\s</code>): check out the section on
        metasyntax characters
      </li>
    </ul>
    <h2 id="basic-greedy-repeat-modifiers">Basic (greedy) Repeat modifiers</h2>
    <p>
      Matching is maximal. Backtracking is minimal, goes character by character.
    </p>
    <table>
      <thead>
        <tr class="header">
          <th>Repeat modifier</th>
          <th>Description</th>
        </tr>
      </thead>
      <tbody>
        <tr class="odd">
          <td><code>+</code></td>
          <td>Match at least once</td>
        </tr>
        <tr class="even">
          <td></td>
          <td></td>
        </tr>
        <tr class="odd">
          <td><code>?</code></td>
          <td>Match at most once</td>
        </tr>
        <tr class="even">
          <td></td>
          <td></td>
        </tr>
        <tr class="odd">
          <td><code>*</code></td>
          <td>Match any number of times</td>
        </tr>
        <tr class="even">
          <td></td>
          <td></td>
        </tr>
        <tr class="odd">
          <td><code>{min,max}</code></td>
          <td>
            match at least <code>min</code> times, and at most
            <code>max</code> times
          </td>
        </tr>
        <tr class="even">
          <td></td>
          <td></td>
        </tr>
        <tr class="odd">
          <td><code>{n}</code></td>
          <td>Match exactly <code>n</code> times</td>
        </tr>
      </tbody>
    </table>
    <p>Examples:</p>
    <ul>
      <li>
        <code>/^a+$/</code> matches any string consisting of one or more
        <code>'a'</code> characters and nothing else
      </li>
      <li>
        <code>/^a?$/</code> matches <code>''</code> or <code>'a'</code>. The
        string may contain at most one <code>'a'</code> character
      </li>
      <li>
        <code>/^a*$/</code> matches the empty string and everything matched by
        <code>/^a+$/</code>
      </li>
      <li>
        <code>/^a{3,5}$/</code> matches <code>'aaa'</code>, <code>'aaaa'</code>,
        and <code>'aaaaa'</code>
      </li>
      <li>
        <code>/(ab){3}/</code> matches any string containing the substring
        <code>'ababab'</code>
      </li>
    </ul>
    <h2 id="lazy-repeat-modifiers">Lazy Repeat Modifiers</h2>
    <p>
      Matching is minimal. During backtracking, we add one character at a time.
    </p>
    <table>
      <thead>
        <tr class="header">
          <th>Repeat modifier (PCRE)</th>
          <th>Description</th>
        </tr>
      </thead>
      <tbody>
        <tr class="odd">
          <td><code>+?</code></td>
          <td>Match at least once</td>
        </tr>
        <tr class="even">
          <td></td>
          <td></td>
        </tr>
        <tr class="odd">
          <td><code>??</code></td>
          <td>Match at most once</td>
        </tr>
        <tr class="even">
          <td></td>
          <td></td>
        </tr>
        <tr class="odd">
          <td><code>*?</code></td>
          <td>Match any number of times</td>
        </tr>
        <tr class="even">
          <td></td>
          <td></td>
        </tr>
        <tr class="odd">
          <td><code>{min,max}?</code></td>
          <td>
            match at least <code>min</code> times, and at most
            <code>max</code> times
          </td>
        </tr>
        <tr class="even">
          <td></td>
          <td></td>
        </tr>
        <tr class="odd">
          <td><code>{n}?</code></td>
          <td>Match exactly <code>n</code> times</td>
        </tr>
      </tbody>
    </table>
    <p>Examples for lazy matching:</p>
    <ul>
      <li>
        <code>/^a+?$/</code> lazily matches any string consisting of one or more
        <code>'a'</code> characters and nothing else
      </li>
      <li>
        <code>/^a??$/</code> lazily matches <code>''</code> or <code>'a'</code>.
        The string may contain at most one <code>'a'</code> character
      </li>
      <li>
        <code>/^a*?$/</code> lazily matches the empty string and everything
        matched by <code>/^a+$/</code>
      </li>
      <li>
        <code>/^a{3,5}?$/</code> lazily matches <code>'aaa'</code>,
        <code>'aaaa'</code>, and <code>'aaaaa'</code>
      </li>
      <li>
        <code>/(ab){3}?/</code> lazily matches any string containing the
        substring <code>'ababab'</code>
      </li>
    </ul>
    <h2 id="capture-groups">Capture groups</h2>
    <ul>
      <li>
        <code>(</code> and <code>)</code> captures a substring inside a regex
      </li>
      <li>
        Capture groups have a reference number equal to the order of the
        starting parentheses of the open parentheses of the capture group
        starting with <code>1</code>
      </li>
      <li>
        <code>(?:</code> and <code>)</code> act as non-capturing parentheses,
        they are not included in the capture group numbering
      </li>
    </ul>
    <p>Example:</p>
    <pre><code>/a(b|c(d|(e))(f))$/
  ^   ^  ^   ^
  |   |  |   |
  1   2  3   4</code></pre>
    <pre><code>&gt; console.table( /^a(b|c(d|(e))(f+))$/.exec( &#39;ab&#39; ) )  
(index) Value
0       &quot;ab&quot;
1       &quot;b&quot;
2       undefined
3       undefined
4       undefined
index   0
input   &quot;ab&quot;

&gt; console.table( /^a(b|c(d|(e))(f+))$/.exec( &#39;aceff&#39; ) )  
(index) Value
0       &quot;aceff&quot;
1       &quot;ceff&quot;
2       &quot;e&quot;
3       &quot;e&quot;
4       &quot;ff&quot;
index   0
input   &quot;aceff&quot;

&gt; console.table( /^a(b|c(?:d|(e))(f+))$/.exec( &#39;aceff&#39; ) )  
(index) Value
0       &quot;aceff&quot;
1       &quot;ceff&quot;
2       &quot;e&quot;
3       &quot;ff&quot;
index   0
input   &quot;aceff&quot;</code></pre>
    <h2 id="lookahead-and-lookbehind">Lookahead and Lookbehind</h2>
    <table>
      <thead>
        <tr class="header">
          <th>Lookahead type</th>
          <th>JavaScript syntax</th>
          <th>Remark</th>
        </tr>
      </thead>
      <tbody>
        <tr class="odd">
          <td>positive lookahead</td>
          <td><code>(?=pattern)</code></td>
          <td></td>
        </tr>
        <tr class="even">
          <td>negative lookahead</td>
          <td><code>(?!pattern)</code></td>
          <td></td>
        </tr>
        <tr class="odd">
          <td>positive lookbehind</td>
          <td><code>(?&lt;=pattern)</code></td>
          <td>only expected in ES2018</td>
        </tr>
        <tr class="even">
          <td>negative lookbehind</td>
          <td><code>(?&lt;!pattern)</code></td>
          <td>only expected in ES2018</td>
        </tr>
        <tr class="odd">
          <td>word boundary</td>
          <td><code>\b</code></td>
          <td>used both as lookahead and lookbehind</td>
        </tr>
        <tr class="even">
          <td>start of string/line</td>
          <td><code>^</code></td>
          <td>used as a lookbehind</td>
        </tr>
        <tr class="odd">
          <td>end of string/line</td>
          <td><code>$</code></td>
          <td>used as a lookbehind</td>
        </tr>
      </tbody>
    </table>
    <ul>
      <li>Lookaheads and lookbehinds are non-capturing</li>
      <li>
        Opposed to Perl 5, lookbehinds can be of variable length, because
        matching is implemented backwards. This means no restrictions in
        lookbehind length
        <ul>
          <li>
            as a consequence of backwards matching, using capture groups inside
            lookbehinds are evaluated according to the rules of backwards
            matching
          </li>
        </ul>
      </li>
    </ul>
    <p>Examples:</p>
    <pre><code>&gt; /a(?=b)/.exec( &#39;ab&#39; )
[&quot;a&quot;, index: 0, input: &quot;ab&quot;]

&gt; /a(?!\d)/.exec( &#39;ab&#39; )
[&quot;a&quot;, index: 0, input: &quot;ab&quot;]
&gt; /a(?!\d)/.exec( &#39;a0&#39; )
null

&gt; /(?&lt;=a)b/.exec( &#39;ab&#39; )
[&quot;b&quot;, index: 1, input: &quot;ab&quot;] // executed in latest Google Chrome

/(?&lt;!a)b/.exec( &#39;Ab&#39; )
[&quot;b&quot;, index: 1, input: &quot;Ab&quot;] // executed in latest Google Chrome

/\bregex\b/.exec( &#39;This regex expression tests word boundaries.&#39; )
[&quot;regex&quot;, index: 5, input: &quot;This regex expression tests word boundaries.&quot;]

/^regex$/.exec( &#39;This\nregex\nexpression\ntests\nanchors.&#39; )
null

/^regex$/m.exec( &#39;This\nregex\nexpression\ntests\nanchors.&#39; )
[&quot;regex&quot;, index: 5, input: &quot;This↵regex↵expression↵tests↵anchors.&quot;]</code></pre>
    <h2 id="possessive-repeat-modifiers">Possessive Repeat Modifiers</h2>
    <p>
      Attempts a maximal (greedy) match first. The loop does not backtrack
      though. It either accepts the maximal match, or fails.
    </p>
    <p>
      Possessive repeat modifiers don’t exist in JavaScript. However, there are
      workarounds.
    </p>
    <p>
      Assuming we don’t have any other capture groups in front of the
      expression, use - <code>(?=(a+))\1</code> instead of the generic PCRE
      pattern <code>a++</code> - <code>(?=(a*))\1</code> instead of the generic
      PCRE pattern <code>a*+</code> - etc.
    </p>
  </body>
</html>
